Index: lemon/cplex.h
===================================================================
--- lemon/cplex.h	(revision 1270)
+++ lemon/cplex.h	(revision 793)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -151,6 +151,4 @@
     bool _message_enabled;
 
-    void _write(std::string file, std::string format) const;
-
   public:
 
@@ -173,17 +171,4 @@
     const cpxlp* cplexLp() const { return _prob; }
 
-#ifdef DOXYGEN
-    /// Write the problem or the solution to a file in the given format
-
-    /// This function writes the problem or the solution
-    /// to a file in the given format.
-    /// Trying to write in an unsupported format will trigger
-    /// \ref lemon::LpBase::UnsupportedFormatError "UnsupportedFormatError".
-    /// \param file The file path
-    /// \param format The output file format.
-    /// Supportted formats are "MPS", "LP" and "SOL".
-    void write(std::string file, std::string format = "MPS") const {}
-#endif
-
   };
 
Index: lemon/cycle_canceling.h
===================================================================
--- lemon/cycle_canceling.h	(revision 1270)
+++ lemon/cycle_canceling.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -36,5 +36,4 @@
 #include <lemon/bellman_ford.h>
 #include <lemon/howard_mmc.h>
-#include <lemon/hartmann_orlin_mmc.h>
 
 namespace lemon {
@@ -48,12 +47,11 @@
   /// \ref CycleCanceling implements three different cycle-canceling
   /// algorithms for finding a \ref min_cost_flow "minimum cost flow"
-  /// \cite amo93networkflows, \cite klein67primal,
-  /// \cite goldberg89cyclecanceling.
-  /// The most efficent one is the \ref CANCEL_AND_TIGHTEN
-  /// "Cancel-and-Tighten" algorithm, thus it is the default method.
-  /// It runs in strongly polynomial time \f$O(n^2 m^2 \log n)\f$,
-  /// but in practice, it is typically orders of magnitude slower than
-  /// the scaling algorithms and \ref NetworkSimplex.
-  /// (For more information, see \ref min_cost_flow_algs "the module page".)
+  /// \ref amo93networkflows, \ref klein67primal,
+  /// \ref goldberg89cyclecanceling.
+  /// The most efficent one (both theoretically and practically)
+  /// is the \ref CANCEL_AND_TIGHTEN "Cancel and Tighten" algorithm,
+  /// thus it is the default method.
+  /// It is strongly polynomial, but in practice, it is typically much
+  /// slower than the scaling algorithms and NetworkSimplex.
   ///
   /// Most of the parameters of the problem (except for the digraph)
@@ -68,9 +66,8 @@
   /// algorithm. By default, it is the same as \c V.
   ///
-  /// \warning Both \c V and \c C must be signed number types.
-  /// \warning All input data (capacities, supply values, and costs) must
+  /// \warning Both number types must be signed and all input data must
   /// be integer.
-  /// \warning This algorithm does not support negative costs for
-  /// arcs having infinite upper bound.
+  /// \warning This algorithm does not support negative costs for such
+  /// arcs that have infinite upper bound.
   ///
   /// \note For more information about the three available methods,
@@ -119,26 +116,25 @@
     ///
     /// \ref CycleCanceling provides three different cycle-canceling
-    /// methods. By default, \ref CANCEL_AND_TIGHTEN "Cancel-and-Tighten"
-    /// is used, which is by far the most efficient and the most robust.
+    /// methods. By default, \ref CANCEL_AND_TIGHTEN "Cancel and Tighten"
+    /// is used, which proved to be the most efficient and the most robust
+    /// on various test inputs.
     /// However, the other methods can be selected using the \ref run()
     /// function with the proper parameter.
     enum Method {
       /// A simple cycle-canceling method, which uses the
-      /// \ref BellmanFord "Bellman-Ford" algorithm for detecting negative
-      /// cycles in the residual network.
-      /// The number of Bellman-Ford iterations is bounded by a successively
-      /// increased limit.
+      /// \ref BellmanFord "Bellman-Ford" algorithm with limited iteration
+      /// number for detecting negative cycles in the residual network.
       SIMPLE_CYCLE_CANCELING,
       /// The "Minimum Mean Cycle-Canceling" algorithm, which is a
       /// well-known strongly polynomial method
-      /// \cite goldberg89cyclecanceling. It improves along a
+      /// \ref goldberg89cyclecanceling. It improves along a
       /// \ref min_mean_cycle "minimum mean cycle" in each iteration.
-      /// Its running time complexity is \f$O(n^2 m^3 \log n)\f$.
+      /// Its running time complexity is O(n<sup>2</sup>m<sup>3</sup>log(n)).
       MINIMUM_MEAN_CYCLE_CANCELING,
-      /// The "Cancel-and-Tighten" algorithm, which can be viewed as an
+      /// The "Cancel And Tighten" algorithm, which can be viewed as an
       /// improved version of the previous method
-      /// \cite goldberg89cyclecanceling.
+      /// \ref goldberg89cyclecanceling.
       /// It is faster both in theory and in practice, its running time
-      /// complexity is \f$O(n^2 m^2 \log n)\f$.
+      /// complexity is O(n<sup>2</sup>m<sup>2</sup>log(n)).
       CANCEL_AND_TIGHTEN
     };
@@ -354,5 +350,5 @@
     ///
     /// Using this function has the same effect as using \ref supplyMap()
-    /// with a map in which \c k is assigned to \c s, \c -k is
+    /// with such a map in which \c k is assigned to \c s, \c -k is
     /// assigned to \c t and all other nodes have zero supply value.
     ///
@@ -577,5 +573,5 @@
     ///
     /// This function returns the total cost of the found flow.
-    /// Its complexity is O(m).
+    /// Its complexity is O(e).
     ///
     /// \note The return type of the function can be specified as a
@@ -615,6 +611,5 @@
     }
 
-    /// \brief Copy the flow values (the primal solution) into the
-    /// given map.
+    /// \brief Return the flow map (the primal solution).
     ///
     /// This function copies the flow value on each arc into the given
@@ -640,6 +635,5 @@
     }
 
-    /// \brief Copy the potential values (the dual solution) into the
-    /// given map.
+    /// \brief Return the potential map (the dual solution).
     ///
     /// This function copies the potential (dual value) of each node
@@ -670,8 +664,4 @@
       }
       if (_sum_supply > 0) return INFEASIBLE;
-
-      // Check lower and upper bounds
-      LEMON_DEBUG(checkBoundMaps(),
-          "Upper bounds must be greater or equal to the lower bounds");
 
 
@@ -783,13 +773,4 @@
 
       return OPTIMAL;
-    }
-
-    // Check if the upper bound is greater or equal to the lower bound
-    // on each arc.
-    bool checkBoundMaps() {
-      for (int j = 0; j != _res_arc_num; ++j) {
-        if (_upper[j] < _lower[j]) return false;
-      }
-      return true;
     }
 
@@ -942,39 +923,16 @@
     // Execute the "Minimum Mean Cycle Canceling" method
     void startMinMeanCycleCanceling() {
-      typedef Path<StaticDigraph> SPath;
+      typedef SimplePath<StaticDigraph> SPath;
       typedef typename SPath::ArcIt SPathArcIt;
       typedef typename HowardMmc<StaticDigraph, CostArcMap>
-        ::template SetPath<SPath>::Create HwMmc;
-      typedef typename HartmannOrlinMmc<StaticDigraph, CostArcMap>
-        ::template SetPath<SPath>::Create HoMmc;
-
-      const double HW_ITER_LIMIT_FACTOR = 1.0;
-      const int HW_ITER_LIMIT_MIN_VALUE = 5;
-
-      const int hw_iter_limit =
-          std::max(static_cast<int>(HW_ITER_LIMIT_FACTOR * _node_num),
-                   HW_ITER_LIMIT_MIN_VALUE);
+        ::template SetPath<SPath>::Create MMC;
 
       SPath cycle;
-      HwMmc hw_mmc(_sgr, _cost_map);
-      hw_mmc.cycle(cycle);
+      MMC mmc(_sgr, _cost_map);
+      mmc.cycle(cycle);
       buildResidualNetwork();
-      while (true) {
-
-        typename HwMmc::TerminationCause hw_tc =
-            hw_mmc.findCycleMean(hw_iter_limit);
-        if (hw_tc == HwMmc::ITERATION_LIMIT) {
-          // Howard's algorithm reached the iteration limit, start a
-          // strongly polynomial algorithm instead
-          HoMmc ho_mmc(_sgr, _cost_map);
-          ho_mmc.cycle(cycle);
-          // Find a minimum mean cycle (Hartmann-Orlin algorithm)
-          if (!(ho_mmc.findCycleMean() && ho_mmc.cycleCost() < 0)) break;
-          ho_mmc.findCycle();
-        } else {
-          // Find a minimum mean cycle (Howard algorithm)
-          if (!(hw_tc == HwMmc::OPTIMAL && hw_mmc.cycleCost() < 0)) break;
-          hw_mmc.findCycle();
-        }
+      while (mmc.findCycleMean() && mmc.cycleCost() < 0) {
+        // Find the cycle
+        mmc.findCycle();
 
         // Compute delta value
@@ -997,15 +955,9 @@
     }
 
-    // Execute the "Cancel-and-Tighten" method
+    // Execute the "Cancel And Tighten" method
     void startCancelAndTighten() {
       // Constants for the min mean cycle computations
       const double LIMIT_FACTOR = 1.0;
       const int MIN_LIMIT = 5;
-      const double HW_ITER_LIMIT_FACTOR = 1.0;
-      const int HW_ITER_LIMIT_MIN_VALUE = 5;
-
-      const int hw_iter_limit =
-          std::max(static_cast<int>(HW_ITER_LIMIT_FACTOR * _node_num),
-                   HW_ITER_LIMIT_MIN_VALUE);
 
       // Contruct auxiliary data vectors
@@ -1181,28 +1133,15 @@
           }
         } else {
-          typedef HowardMmc<StaticDigraph, CostArcMap> HwMmc;
-          typedef HartmannOrlinMmc<StaticDigraph, CostArcMap> HoMmc;
+          typedef HowardMmc<StaticDigraph, CostArcMap> MMC;
           typedef typename BellmanFord<StaticDigraph, CostArcMap>
             ::template SetDistMap<CostNodeMap>::Create BF;
 
           // Set epsilon to the minimum cycle mean
-          Cost cycle_cost = 0;
-          int cycle_size = 1;
           buildResidualNetwork();
-          HwMmc hw_mmc(_sgr, _cost_map);
-          if (hw_mmc.findCycleMean(hw_iter_limit) == HwMmc::ITERATION_LIMIT) {
-            // Howard's algorithm reached the iteration limit, start a
-            // strongly polynomial algorithm instead
-            HoMmc ho_mmc(_sgr, _cost_map);
-            ho_mmc.findCycleMean();
-            epsilon = -ho_mmc.cycleMean();
-            cycle_cost = ho_mmc.cycleCost();
-            cycle_size = ho_mmc.cycleSize();
-          } else {
-            // Set epsilon
-            epsilon = -hw_mmc.cycleMean();
-            cycle_cost = hw_mmc.cycleCost();
-            cycle_size = hw_mmc.cycleSize();
-          }
+          MMC mmc(_sgr, _cost_map);
+          mmc.findCycleMean();
+          epsilon = -mmc.cycleMean();
+          Cost cycle_cost = mmc.cycleCost();
+          int cycle_size = mmc.cycleSize();
 
           // Compute feasible potentials for the current epsilon
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 1270)
+++ lemon/dfs.h	(revision 1159)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -153,5 +153,5 @@
     typedef PredMapPath<Digraph, PredMap> Path;
 
-    ///The \ref lemon::DfsDefaultTraits "traits class" of the algorithm.
+    ///The \ref DfsDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 1270)
+++ lemon/dijkstra.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -228,9 +228,9 @@
     ///The heap type used by the algorithm.
     typedef typename TR::Heap Heap;
-    /// \brief The \ref lemon::DijkstraDefaultOperationTraits
-    /// "operation traits class" of the algorithm.
+    ///\brief The \ref DijkstraDefaultOperationTraits "operation traits class"
+    ///of the algorithm.
     typedef typename TR::OperationTraits OperationTraits;
 
-    ///The \ref lemon::DijkstraDefaultTraits "traits class" of the algorithm.
+    ///The \ref DijkstraDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
Index: lemon/dimacs.h
===================================================================
--- lemon/dimacs.h	(revision 1270)
+++ lemon/dimacs.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/edge_set.h
===================================================================
--- lemon/edge_set.h	(revision 1270)
+++ lemon/edge_set.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/euler.h
===================================================================
--- lemon/euler.h	(revision 1270)
+++ lemon/euler.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -37,5 +37,5 @@
   ///Euler tour iterator for digraphs.
 
-  /// \ingroup graph_properties
+  /// \ingroup graph_prop
   ///This iterator provides an Euler tour (Eulerian circuit) of a \e directed
   ///graph (if there exists) and it converts to the \c Arc type of the digraph.
Index: lemon/fractional_matching.h
===================================================================
--- lemon/fractional_matching.h	(revision 1270)
+++ lemon/fractional_matching.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -124,6 +124,6 @@
   public:
 
-    /// \brief The \ref lemon::MaxFractionalMatchingDefaultTraits
-    /// "traits class" of the algorithm.
+    /// \brief The \ref MaxFractionalMatchingDefaultTraits "traits
+    /// class" of the algorithm.
     typedef TR Traits;
     /// The type of the graph the algorithm runs on.
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1270)
+++ lemon/full_graph.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -622,458 +622,4 @@
   };
 
-  class FullBpGraphBase {
-
-  protected:
-
-    int _red_num, _blue_num;
-    int _node_num, _edge_num;
-
-  public:
-
-    typedef FullBpGraphBase Graph;
-
-    class Node;
-    class Arc;
-    class Edge;
-
-    class Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Node(int id) { _id = id;}
-
-    public:
-      Node() {}
-      Node (Invalid) { _id = -1; }
-      bool operator==(const Node& node) const {return _id == node._id;}
-      bool operator!=(const Node& node) const {return _id != node._id;}
-      bool operator<(const Node& node) const {return _id < node._id;}
-    };
-
-    class RedNode : public Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      explicit RedNode(int pid) : Node(pid) {}
-
-    public:
-      RedNode() {}
-      RedNode(const RedNode& node) : Node(node) {}
-      RedNode(Invalid) : Node(INVALID){}
-    };
-
-    class BlueNode : public Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      explicit BlueNode(int pid) : Node(pid) {}
-
-    public:
-      BlueNode() {}
-      BlueNode(const BlueNode& node) : Node(node) {}
-      BlueNode(Invalid) : Node(INVALID){}
-    };
-
-    class Edge {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Edge(int id) { _id = id;}
-
-    public:
-      Edge() {}
-      Edge (Invalid) { _id = -1; }
-      bool operator==(const Edge& arc) const {return _id == arc._id;}
-      bool operator!=(const Edge& arc) const {return _id != arc._id;}
-      bool operator<(const Edge& arc) const {return _id < arc._id;}
-    };
-
-    class Arc {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Arc(int id) { _id = id;}
-
-    public:
-      operator Edge() const {
-        return _id != -1 ? edgeFromId(_id / 2) : INVALID;
-      }
-
-      Arc() {}
-      Arc (Invalid) { _id = -1; }
-      bool operator==(const Arc& arc) const {return _id == arc._id;}
-      bool operator!=(const Arc& arc) const {return _id != arc._id;}
-      bool operator<(const Arc& arc) const {return _id < arc._id;}
-    };
-
-
-  protected:
-
-    FullBpGraphBase()
-      : _red_num(0), _blue_num(0), _node_num(0), _edge_num(0) {}
-
-    void construct(int redNum, int blueNum) {
-      _red_num = redNum; _blue_num = blueNum;
-      _node_num = redNum + blueNum; _edge_num = redNum * blueNum;
-    }
-
-  public:
-
-    typedef True NodeNumTag;
-    typedef True EdgeNumTag;
-    typedef True ArcNumTag;
-
-    int nodeNum() const { return _node_num; }
-    int redNum() const { return _red_num; }
-    int blueNum() const { return _blue_num; }
-    int edgeNum() const { return _edge_num; }
-    int arcNum() const { return 2 * _edge_num; }
-
-    int maxNodeId() const { return _node_num - 1; }
-    int maxRedId() const { return _red_num - 1; }
-    int maxBlueId() const { return _blue_num - 1; }
-    int maxEdgeId() const { return _edge_num - 1; }
-    int maxArcId() const { return 2 * _edge_num - 1; }
-
-    bool red(Node n) const { return n._id < _red_num; }
-    bool blue(Node n) const { return n._id >= _red_num; }
-
-    static RedNode asRedNodeUnsafe(Node n) { return RedNode(n._id); }
-    static BlueNode asBlueNodeUnsafe(Node n) { return BlueNode(n._id); }
-
-    Node source(Arc a) const {
-      if (a._id & 1) {
-        return Node((a._id >> 1) % _red_num);
-      } else {
-        return Node((a._id >> 1) / _red_num + _red_num);
-      }
-    }
-    Node target(Arc a) const {
-      if (a._id & 1) {
-        return Node((a._id >> 1) / _red_num + _red_num);
-      } else {
-        return Node((a._id >> 1) % _red_num);
-      }
-    }
-
-    RedNode redNode(Edge e) const {
-      return RedNode(e._id % _red_num);
-    }
-    BlueNode blueNode(Edge e) const {
-      return BlueNode(e._id / _red_num + _red_num);
-    }
-
-    static bool direction(Arc a) {
-      return (a._id & 1) == 1;
-    }
-
-    static Arc direct(Edge e, bool d) {
-      return Arc(e._id * 2 + (d ? 1 : 0));
-    }
-
-    void first(Node& node) const {
-      node._id = _node_num - 1;
-    }
-
-    static void next(Node& node) {
-      --node._id;
-    }
-
-    void first(RedNode& node) const {
-      node._id = _red_num - 1;
-    }
-
-    static void next(RedNode& node) {
-      --node._id;
-    }
-
-    void first(BlueNode& node) const {
-      if (_red_num == _node_num) node._id = -1;
-      else node._id = _node_num - 1;
-    }
-
-    void next(BlueNode& node) const {
-      if (node._id == _red_num) node._id = -1;
-      else --node._id;
-    }
-
-    void first(Arc& arc) const {
-      arc._id = 2 * _edge_num - 1;
-    }
-
-    static void next(Arc& arc) {
-      --arc._id;
-    }
-
-    void first(Edge& arc) const {
-      arc._id = _edge_num - 1;
-    }
-
-    static void next(Edge& arc) {
-      --arc._id;
-    }
-
-    void firstOut(Arc &a, const Node& v) const {
-      if (v._id < _red_num) {
-        a._id = 2 * (v._id + _red_num * (_blue_num - 1)) + 1;
-      } else {
-        a._id = 2 * (_red_num - 1 + _red_num * (v._id - _red_num));
-      }
-    }
-    void nextOut(Arc &a) const {
-      if (a._id & 1) {
-        a._id -= 2 * _red_num;
-        if (a._id < 0) a._id = -1;
-      } else {
-        if (a._id % (2 * _red_num) == 0) a._id = -1;
-        else a._id -= 2;
-      }
-    }
-
-    void firstIn(Arc &a, const Node& v) const {
-      if (v._id < _red_num) {
-        a._id = 2 * (v._id + _red_num * (_blue_num - 1));
-      } else {
-        a._id = 2 * (_red_num - 1 + _red_num * (v._id - _red_num)) + 1;
-      }
-    }
-    void nextIn(Arc &a) const {
-      if (a._id & 1) {
-        if (a._id % (2 * _red_num) == 1) a._id = -1;
-        else a._id -= 2;
-      } else {
-        a._id -= 2 * _red_num;
-        if (a._id < 0) a._id = -1;
-      }
-    }
-
-    void firstInc(Edge &e, bool& d, const Node& v) const {
-      if (v._id < _red_num) {
-        d = true;
-        e._id = v._id + _red_num * (_blue_num - 1);
-      } else {
-        d = false;
-        e._id = _red_num - 1 + _red_num * (v._id - _red_num);
-      }
-    }
-    void nextInc(Edge &e, bool& d) const {
-      if (d) {
-        e._id -= _red_num;
-        if (e._id < 0) e._id = -1;
-      } else {
-        if (e._id % _red_num == 0) e._id = -1;
-        else --e._id;
-      }
-    }
-
-    static int id(const Node& v) { return v._id; }
-    int id(const RedNode& v) const { return v._id; }
-    int id(const BlueNode& v) const { return v._id - _red_num; }
-    static int id(Arc e) { return e._id; }
-    static int id(Edge e) { return e._id; }
-
-    static Node nodeFromId(int id) { return Node(id);}
-    static Arc arcFromId(int id) { return Arc(id);}
-    static Edge edgeFromId(int id) { return Edge(id);}
-
-    bool valid(Node n) const {
-      return n._id >= 0 && n._id < _node_num;
-    }
-    bool valid(Arc a) const {
-      return a._id >= 0 && a._id < 2 * _edge_num;
-    }
-    bool valid(Edge e) const {
-      return e._id >= 0 && e._id < _edge_num;
-    }
-
-    RedNode redNode(int index) const {
-      return RedNode(index);
-    }
-
-    int index(RedNode n) const {
-      return n._id;
-    }
-
-    BlueNode blueNode(int index) const {
-      return BlueNode(index + _red_num);
-    }
-
-    int index(BlueNode n) const {
-      return n._id - _red_num;
-    }
-
-    void clear() {
-      _red_num = 0; _blue_num = 0;
-      _node_num = 0; _edge_num = 0;
-    }
-
-    Edge edge(const Node& u, const Node& v) const {
-      if (u._id < _red_num) {
-        if (v._id < _red_num) {
-          return Edge(-1);
-        } else {
-          return Edge(u._id + _red_num * (v._id - _red_num));
-        }
-      } else {
-        if (v._id < _red_num) {
-          return Edge(v._id + _red_num * (u._id - _red_num));
-        } else {
-          return Edge(-1);
-        }
-      }
-    }
-
-    Arc arc(const Node& u, const Node& v) const {
-      if (u._id < _red_num) {
-        if (v._id < _red_num) {
-          return Arc(-1);
-        } else {
-          return Arc(2 * (u._id + _red_num * (v._id - _red_num)) + 1);
-        }
-      } else {
-        if (v._id < _red_num) {
-          return Arc(2 * (v._id + _red_num * (u._id - _red_num)));
-        } else {
-          return Arc(-1);
-        }
-      }
-    }
-
-    typedef True FindEdgeTag;
-    typedef True FindArcTag;
-
-    Edge findEdge(Node u, Node v, Edge prev = INVALID) const {
-      return prev != INVALID ? INVALID : edge(u, v);
-    }
-
-    Arc findArc(Node s, Node t, Arc prev = INVALID) const {
-      return prev != INVALID ? INVALID : arc(s, t);
-    }
-
-  };
-
-  typedef BpGraphExtender<FullBpGraphBase> ExtendedFullBpGraphBase;
-
-  /// \ingroup graphs
-  ///
-  /// \brief An undirected full bipartite graph class.
-  ///
-  /// FullBpGraph is a simple and fast implmenetation of undirected
-  /// full bipartite graphs. It contains an edge between every
-  /// red-blue pairs of nodes, therefore the number of edges is
-  /// <tt>nr*nb</tt>.  This class is completely static and it needs
-  /// constant memory space.  Thus you can neither add nor delete
-  /// nodes or edges, however the structure can be resized using
-  /// resize().
-  ///
-  /// This type fully conforms to the \ref concepts::BpGraph "BpGraph concept".
-  /// Most of its member functions and nested classes are documented
-  /// only in the concept class.
-  ///
-  /// This class provides constant time counting for nodes, edges and arcs.
-  ///
-  /// \sa FullGraph
-  class FullBpGraph : public ExtendedFullBpGraphBase {
-  public:
-
-    typedef ExtendedFullBpGraphBase Parent;
-
-    /// \brief Default constructor.
-    ///
-    /// Default constructor. The number of nodes and edges will be zero.
-    FullBpGraph() { construct(0, 0); }
-
-    /// \brief Constructor
-    ///
-    /// Constructor.
-    /// \param redNum The number of the red nodes.
-    /// \param blueNum The number of the blue nodes.
-    FullBpGraph(int redNum, int blueNum) { construct(redNum, blueNum); }
-
-    /// \brief Resizes the graph
-    ///
-    /// This function resizes the graph. It fully destroys and
-    /// rebuilds the structure, therefore the maps of the graph will be
-    /// reallocated automatically and the previous values will be lost.
-    void resize(int redNum, int blueNum) {
-      Parent::notifier(Arc()).clear();
-      Parent::notifier(Edge()).clear();
-      Parent::notifier(Node()).clear();
-      Parent::notifier(BlueNode()).clear();
-      Parent::notifier(RedNode()).clear();
-      construct(redNum, blueNum);
-      Parent::notifier(RedNode()).build();
-      Parent::notifier(BlueNode()).build();
-      Parent::notifier(Node()).build();
-      Parent::notifier(Edge()).build();
-      Parent::notifier(Arc()).build();
-    }
-
-    using Parent::redNode;
-    using Parent::blueNode;
-
-    /// \brief Returns the red node with the given index.
-    ///
-    /// Returns the red node with the given index. Since this
-    /// structure is completely static, the red nodes can be indexed
-    /// with integers from the range <tt>[0..redNum()-1]</tt>.
-    /// \sa redIndex()
-    RedNode redNode(int index) const { return Parent::redNode(index); }
-
-    /// \brief Returns the index of the given red node.
-    ///
-    /// Returns the index of the given red node. Since this structure
-    /// is completely static, the red nodes can be indexed with
-    /// integers from the range <tt>[0..redNum()-1]</tt>.
-    ///
-    /// \sa operator()()
-    int index(RedNode node) const { return Parent::index(node); }
-
-    /// \brief Returns the blue node with the given index.
-    ///
-    /// Returns the blue node with the given index. Since this
-    /// structure is completely static, the blue nodes can be indexed
-    /// with integers from the range <tt>[0..blueNum()-1]</tt>.
-    /// \sa blueIndex()
-    BlueNode blueNode(int index) const { return Parent::blueNode(index); }
-
-    /// \brief Returns the index of the given blue node.
-    ///
-    /// Returns the index of the given blue node. Since this structure
-    /// is completely static, the blue nodes can be indexed with
-    /// integers from the range <tt>[0..blueNum()-1]</tt>.
-    ///
-    /// \sa operator()()
-    int index(BlueNode node) const { return Parent::index(node); }
-
-    /// \brief Returns the edge which connects the given nodes.
-    ///
-    /// Returns the edge which connects the given nodes.
-    Edge edge(const Node& u, const Node& v) const {
-      return Parent::edge(u, v);
-    }
-
-    /// \brief Returns the arc which connects the given nodes.
-    ///
-    /// Returns the arc which connects the given nodes.
-    Arc arc(const Node& u, const Node& v) const {
-      return Parent::arc(u, v);
-    }
-
-    /// \brief Number of nodes.
-    int nodeNum() const { return Parent::nodeNum(); }
-    /// \brief Number of red nodes.
-    int redNum() const { return Parent::redNum(); }
-    /// \brief Number of blue nodes.
-    int blueNum() const { return Parent::blueNum(); }
-    /// \brief Number of arcs.
-    int arcNum() const { return Parent::arcNum(); }
-    /// \brief Number of edges.
-    int edgeNum() const { return Parent::edgeNum(); }
-  };
-
 
 } //namespace lemon
Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 1270)
+++ lemon/glpk.cc	(revision 1142)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -581,13 +581,4 @@
       break;
     }
-  }
-
-  void GlpkBase::_write(std::string file, std::string format) const
-  {
-    if(format == "MPS")
-      glp_write_mps(lp, GLP_MPS_FILE, 0, file.c_str());
-    else if(format == "LP")
-      glp_write_lp(lp, 0, file.c_str());
-    else throw UnsupportedFormatError(format);
   }
 
@@ -1008,5 +999,3 @@
   const char* GlpkMip::_solverName() const { return "GlpkMip"; }
 
-
-
 } //END OF NAMESPACE LEMON
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 1270)
+++ lemon/glpk.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -116,6 +116,4 @@
     virtual void _messageLevel(MessageLevel level);
 
-    virtual void _write(std::string file, std::string format) const;
-
   private:
 
@@ -147,17 +145,4 @@
     int lpxCol(Col c) const { return cols(id(c)); }
 
-#ifdef DOXYGEN
-    /// Write the problem or the solution to a file in the given format
-
-    /// This function writes the problem or the solution
-    /// to a file in the given format.
-    /// Trying to write in an unsupported format will trigger
-    /// \ref LpBase::UnsupportedFormatError.
-    /// \param file The file path
-    /// \param format The output file format.
-    /// Supportted formats are "MPS" and "LP".
-    void write(std::string file, std::string format = "MPS") const {}
-#endif
-
   };
 
Index: lemon/gomory_hu.h
===================================================================
--- lemon/gomory_hu.h	(revision 1270)
+++ lemon/gomory_hu.h	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -47,5 +47,5 @@
   ///
   /// The algorithm calculates \e n-1 distinct minimum cuts (currently with
-  /// the \ref Preflow algorithm), thus it has \f$O(n^3\sqrt{m})\f$ overall
+  /// the \ref Preflow algorithm), thus it has \f$O(n^3\sqrt{e})\f$ overall
   /// time complexity. It calculates a rooted Gomory-Hu tree.
   /// The structure of the tree and the edge weights can be
